package org.dromara.elevator.service;

import org.dromara.elevator.domain.vo.EExpertConsultVo;
import org.dromara.elevator.domain.bo.EExpertConsultBo;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 专家咨询Service接口
 *
 * @author ym
 * @date 2024-10-29
 */
public interface IEExpertConsultService {

    /**
     * 查询专家咨询
     *
     * @param id 主键
     * @return 专家咨询
     */
    EExpertConsultVo queryById(Long id);

    /**
     * 分页查询专家咨询列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 专家咨询分页列表
     */
    TableDataInfo<EExpertConsultVo> queryPageList(EExpertConsultBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的专家咨询列表
     *
     * @param bo 查询条件
     * @return 专家咨询列表
     */
    List<EExpertConsultVo> queryList(EExpertConsultBo bo);

    /**
     * 新增专家咨询
     *
     * @param bo 专家咨询
     * @return 是否新增成功
     */
    Boolean insertByBo(EExpertConsultBo bo);

    /**
     * 修改专家咨询
     *
     * @param bo 专家咨询
     * @return 是否修改成功
     */
    Boolean updateByBo(EExpertConsultBo bo);

    /**
     * 校验并批量删除专家咨询信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 接收咨询工单
     *
     * @param bo 工单参数
     * @return 是否成功
     */
    Boolean receive(EExpertConsultBo bo);

    /**
     * 完成咨询工单
     *
     * @param bo 工单参数
     * @return 是否成功
     */
    Boolean complete(EExpertConsultBo bo);

    /**
     * 审核咨询工单
     *
     * @param bo 工单参数
     * @return 是否成功
     */
    Boolean audit(EExpertConsultBo bo);
}
